package com.ruoyi.project.sems.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.framework.aspectj.lang.annotation.DataScope;
import com.ruoyi.framework.aspectj.lang.annotation.DataScopePlant;
import com.ruoyi.project.sems.domain.TReportYlrq;
import com.ruoyi.project.sems.domain.TSpecdevYlrq;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 压力容器年检报告Mapper接口
 *
 * @author ruoyi
 * @date 2021-09-02
 */
@Component("tReportYlrqMapper")
public interface TReportYlrqMapper extends BaseMapper<TReportYlrq> {

    /**
     * 插入需要新增的压力管道年检报告
     *
     * @param tSpecdevYlrq 数据源-压力容器在用台账数据
     * @return
     */
    public int insertByTSpecdevYlrq(TSpecdevYlrq tSpecdevYlrq);

    /**
     * 更新已存在的压力容器年检报告
     *
     * @param tSpecdevYlrq 数据源-压力容器在用台账数据
     * @return
     */
    public int updateByTSpecdevYlrq(TSpecdevYlrq tSpecdevYlrq);

    /**
     * 根据excel导入的数据进行数据更新操作
     * 根据 位号、使用证、注册编号 3个条件去更新
     * @param tReportYlrq excel中获取的数据
     * @return
     */
    public int updateForImport(TReportYlrq tReportYlrq);

    /**
     * 获取压力容器在用台账与压力管道年检数据需要插入的id
     *
     * @return
     */
    public List<Long> queryNeedInsertIds();

    /**
     * 获取压力容器在用台账与压力容器年检数据需要删除的部分id
     *
     * @return
     */
    public List<Long> queryNeedDeleteIds();

    /**
     * 获取压力容器在用台账与压力容器年检数据不一致部分id
     *
     * @return
     */
    public List<Long> queryNeedUpdateIds();

    /**
     * 查询压力容器年检报告
     *
     * @param id 压力容器年检报告ID
     * @return 压力容器年检报告
     */
    public TReportYlrq selectTReportYlrqById(Long id);

    /**
     * 查询压力容器年检报告列表
     *
     * @param tReportYlrq 压力容器年检报告
     * @return 压力容器年检报告集合
     */
    @DataScopePlant(deptAlias = "y")
    public List<TReportYlrq> selectTReportYlrqList(TReportYlrq tReportYlrq);

    /**
     * 新增压力容器年检报告
     *
     * @param tReportYlrq 压力容器年检报告
     * @return 结果
     */
    public int insertTReportYlrq(TReportYlrq tReportYlrq);

    /**
     * 修改压力容器年检报告
     *
     * @param tReportYlrq 压力容器年检报告
     * @return 结果
     */
    public int updateTReportYlrq(TReportYlrq tReportYlrq);

    /**
     * 删除压力容器年检报告
     *
     * @param id 压力容器年检报告ID
     * @return 结果
     */
    public int deleteTReportYlrqById(Long id);

    /**
     * 批量删除压力容器年检报告
     *
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteTReportYlrqByIds(Long[] ids);

    void sysnReport(TReportYlrq tReportYlrq);
}
